import MathUtil from "./MathUtil";
import {Config} from "./Config";

export default class StringUtil {
    public static getCheckString(address:string, headInfo) {
        return `配置文件:${headInfo.excelPath}: ${headInfo.sheetname} :${address}`;
    }

    public static getTsClassString(jsobj, filename, TStsr, headInfo) {
        let index = filename.indexOf('Object')
        if (index >= 0) {
            filename = filename.slice(0, index)
        }
        let s = `export class ${filename}`
        s += '\r\n{\r\n'
        for (let col = 0; col < headInfo.keys.length; col++) {
            let cur = headInfo.keys[col]
            if (cur.outputclient) {
                let many = ''
                if (cur.arrayNum == 2) {
                    many = '[]'
                } else if (cur.arrayNum == 3){
                    many = '[][]'
                }
                s += `    public ${cur.name}: ${cur.type}${many};\r\n`
            }
        }

        s += '}\r\n'
        TStsr += s
        return TStsr
    }

    /**
     * 
     * @param jsobj 
     * @param filename 
     * @param TStsr 
     */
    public static getTsFileString(jsobj, filename, TStsr, headInfo) {
        var s = ''
        let headKeys = headInfo.keys.filter(val => val.outputclient)
        for (let i = 0; i < jsobj.length; i++) {
            s += `\r\n        ${Config.objectKey?`'${jsobj[i][Config.objectKey]}':`:''}{ `
            let keys = Object.keys(jsobj[i]);
            for (let j = 0; j < keys.length; j++) {
                // s += '\r\n\t\t\t'
                let value = jsobj[i][keys[j]]
                let cur = headKeys[j]
                if (cur.type == 'string') { value = `'${value}'` }
                s += `${keys[j]}: ${value}, `
            }
            if (s.substr(s.length - 2, 2) == ', ') {
                s = s.substr(0, s.length - 2)
            }
            s += ' },'
        }
        if(Config.objectKey){
            s = s.substr(0, s.length - 1)  // 单个对象为表去掉多余的数组逗号
            return `${TStsr}${s}`
        }
        let index = filename.indexOf('Object')
        if (index != -1) {
            filename = filename.slice(0, index)
            s = s.substr(0, s.length - 1)  // 单个对象为表去掉多余的数组逗号
            return `${TStsr}\r\n    public static ${filename}: ${filename} = ${s};\r\n`
        }
        return `${TStsr}\r\n    public static ${filename}: ${filename}[] = [${s}\r\n    ];`
    }

    public static getTsFileString2(jsobj, filename, TStsr, headInfo) {
        let ss = `import { Config } from './Config';`;
        var s = ''
        let headKeys = headInfo.keys.filter(val => val.outputclient)
        for (let i = 0; i < jsobj.length; i++) {
            s += '\r\n    {'
            let keys = Object.keys(jsobj[i]);
            for (let j = 0; j < keys.length; j++) {
                let value = jsobj[i][keys[j]]
                let cur = headKeys[j]
                if (cur.type == 'string' || cur.type == 'String') { value = `'${value}'` }
                s += `${keys[j]}: ${value}, `
            }
            if (s.substr(s.length - 2, 2) == ', ') {
                s = s.substr(0, s.length - 2)
            }
            s += '},'
        }
        let index = filename.indexOf('Object')
        if (index != -1) {
            filename = filename.slice(0, index)
            s = s.substr(0, s.length - 1)  // 单个对象为表去掉多余的数组逗号
            return `${ss}\r\n\r\nConfig.${filename} = ${s};\r\n`
        }
        return `${ss}\r\n\r\nConfig.${filename} = [${s}\r\n];`
    }

    public static getTsFileString3(jsobj, headInfo) {
        let headKeys = headInfo.keys.filter(val => val.outputclient)
        for (let i = 0; i < jsobj.length; i++) {
            let keys = Object.keys(jsobj[i]);
            for (let j = 0; j < keys.length; j++) {
                let value = jsobj[i][keys[j]]
                let cur = headKeys[j]
                if (cur.isArray) {
                    jsobj[i][keys[j]] = eval(value)
                }
            }
        }
    }


    public static getTsFileHead(filename, TStsr) {
        return `${TStsr}\r\n    public static ${filename}: ${filename}[] = [];`
    }
 

    /**
     * 
     * @param jsobj 
     * @param filename 
     * @param configData 
     */
    public static getJsFileString(jsobj, filename, configData, headInfo) {
        let s = ''
        let headKeys = headInfo.keys.filter(val => val.outputclient)
        for (let i = 0; i < jsobj.length; i++) {
            s += '\r\n\t\t{'
            let keys = Object.keys(jsobj[i]);
            for (let j = 0; j < keys.length; j++) {
                s += '\r\n\t\t\t'
                let value = jsobj[i][keys[j]]
                let cur = headKeys[j]
                if (cur.type == 'string') { value = `'${value}'` }
                s += `${keys[j]}: ${value},`
            }
            s += '\r\n\t\t},'
        }
    
        let index = filename.indexOf('Object')
        if (index != -1) {
            filename = filename.slice(0, index)
            return `${configData}\t${filename}:${s}\r\n`
        }
        return `${configData}\t${filename}: [${s}\r\n\t],\r\n`
    }

    public static getCsvFileString(csvobj) {
        var ret = ''
        for (let i = 0; i < csvobj.length; i++) {
            let arr = Object.values(csvobj[i])
            for (let j = 0; j < arr.length; j++) {
                if (j == arr.length - 1) {
                    ret = `${ret + arr[j]}\n`
                } else {
                    ret = `${ret + arr[j]},`
                }
            }
        }
        return ret;
    }

    public static getHsvFileString(csvobj) {
        var ret = ''
        for (let i = -1; i < csvobj.length; i++) {
            let arr = null;
            if (i == -1) {
                arr = Object.keys(csvobj[0])
            } else {
                arr = Object.values(csvobj[i])
            }
            for (let j = 0; j < arr.length; j++) {
                if (j == arr.length - 1) {
                    ret = `${ret + arr[j]}\n`
                } else {
                    ret = `${ret + arr[j]},`
                }
            }
        }
        return ret;
    }

    public static replaceAll(text:string, oldString:string, newString:string) {
        return text.replace(new RegExp(oldString, 'g'), newString);
    };

    public static replaceDoubleMid (text:string, oldString:string, newStringCallback:Function, checkIsNumber:boolean = false) {
        let globalReg = new RegExp(`\\${oldString}[^\\${oldString}]+\\${oldString}`, 'g')
        let reg = new RegExp(`\\${oldString}[^\\${oldString}]+\\${oldString}`)
        let arr = text.match(globalReg)
        if (arr) {
            for(let i = 0; i < arr.length; i++) {
                let mid = arr[i].substr(1, arr[i].length - 2);
                if (checkIsNumber) {
                    if (MathUtil.isNumber(mid)) {
                        let newString = newStringCallback(mid) // 
                        text = text.replace(reg, newString)  // 从左到右逐个替换
                    } else {
                        // 报错
                    }
                } else {
                    let newString = newStringCallback(mid)
                    text = text.replace(reg, newString)  // 从左到右逐个替换
                }
            }
        }
        return text;
    }

}
